'==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~
'     MaskEdit                by William Burns  updated 08/10/2003
'
'Example usage:
'
'#Include "MaskEdit.inc"
'CallBack Function DLGPROC
'   Select Case CbMsg
'      Case %WM_COMMAND
'         Select Case CbCtl
'            Case  %TXTDATE  'one of my textboxes
'               If CbCtlMsg=%EN_CHANGE Then Call MaskEdit(CbHndl,%TXTDATE,"##/##/####") '
'            Case  %TXTPHONE
'               If CbCtlMsg=%EN_UPDATE Then Call MaskEdit(CbHndl,%TXTPHONE,"(###)###-####")
'     ...
'
'
'The mask parameter uses similar rules to the MaskedEdit VB control:
'
'  # Digit placeholder. (entry required) For example: 0 - 9.
'  9 Digit placeholder. (entry Optional) For example: 0 - 9.
'  . Decimal placeholder. The actual character used is the one specified As the decimal placeholder In your international settings. This character is treated As a literal For masking purposes.
'  , Thousands separator. The actual character used is the one specified As the thousands separator In your international settings. This character is treated As a literal For masking purposes.
'  : Time separator. The actual character used is the one specified As the time separator In your international settings. This character is treated As a literal For masking purposes.
'  / Date separator. The actual character used is the one specified As the date separator In your international settings. This character is treated As a literal For masking purposes.
'  \ Treat the Next character In the mask String As a literal. This allows you To include the '#', '&', 'A', and '?' characters in the mask. This character is treated as a literal for masking purposes.
'  & Character placeholder. Valid values For this placeholder are ANSI characters In the following ranges: 32-126 And 128-255.  (entry required)
'  > Convert All the characters that follow To uppercase.
'  < Convert All the characters that follow To lowercase.
'  A Alphanumeric character placeholder (entry required). For example: a - z, A - Z, Or 0 - 9.
'  a Alphanumeric character placeholder (entry Optional).
'  C Character Or space placeholder (entry Optional).
'  L Letter placeholder. (entry required)
'  ? Letter placeholder. For example: a - z Or A - Z. (entry optional)
'  Literal All other symbols are displayed As literals; that is, As themselves.
'
'==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~
'
'
'==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~
FUNCTION MaskEdit(BYVAL hWnd AS DWORD, BYVAL iControlID AS LONG, BYVAL sMask AS STRING) AS LONG
   STATIC sSafety    AS STRING
   LOCAL iRet        AS LONG
   LOCAL hEdit       AS DWORD
   LOCAL iCurPos     AS LONG
   LOCAL sTextIn     AS STRING
   LOCAL sTextOut    AS STRING
   LOCAL sNextChar   AS STRING
   LOCAL iCount      AS LONG
   LOCAL iMaskCount  AS LONG
   LOCAL sMaskFields AS STRING
   LOCAL iCaps       AS LONG
   LOCAL iDone       AS LONG
   LOCAL zBuff       AS ASCIIZ * 50
   IF INSTR(1,sSafety, STR$(hWnd) + STR$(iControlID)) THEN     'use this to stop endless loop caused by my updates
      sSafety = REMOVE$(sSafety,STR$(hWnd) + STR$(iControlID))
      EXIT FUNCTION  'this message is because of our update so exit without updating again
   ELSE
      sSafety = sSafety + STR$(hWnd) + STR$(iControlID)        'store our control info to ignore our next message caused by this function updating the editbox
   END IF
   hEdit = GetDlgItem(hWnd, iControlID)                              'get editbox handle
   iRet = SendMessage( hEdit, %WM_GETTEXTLENGTH, 0, 0)                 'get text len
   sTextIn = SPACE$(iRet + 1)                                        'create a buffer to hold it
   iRet = SendMessage( hEdit, %WM_GETTEXT, iRet + 1, STRPTR(sTextIn) ) 'get text
   CALL SendMessage( hEdit, %EM_GETSEL, BYVAL 0, VARPTR(iCurPos))      'get cursor pos
   sTextIn = LEFT$(sTextIn,iCurPos) + MID$(sTextIn, iCurPos + 2)     'no insert so remove following char
   DO 'create a mask field layout
      INCR iMaskCount
      IF iMaskCount > LEN(sMask) THEN EXIT LOOP
      IF INSTR(1, "<>", MID$(sMask,iMaskCount,1)) THEN ITERATE LOOP  'skip these chars
      IF INSTR(1, "#9&AaCL?", MID$(sMask,iMaskCount,1)) THEN 'data field
         sMaskFields = sMaskFields + "D"  'mark as data field
      ELSE
         sMaskFields = sMaskFields + "."  'mark as non-field
      END IF
      IF MID$(sMask,iMaskCount,1) = "\" THEN INCR iMaskCount         'next is literal so skip one pos
   LOOP
   IF LEN(sTextIn) = 1 THEN iCurPos = MAX(INSTR(1,sMaskFields,"D"),1)'first char typed
   iMaskCount = 0 'reset for below
   iDone = %TRUE  'true unless we find a missing required char
   DO
      INCR iMaskCount                                          'position of mask string
      IF iMaskCount > LEN(sMask) THEN EXIT LOOP
      INCR iCount                                              'position of input string
      IF iCount > LEN(sTextIn) THEN
         sNextChar = ""
      ELSE
         sNextChar = MID$(sTextIn,iCount,1)                    'get input character
      END IF
      IF iCaps = 1 THEN sNextChar = LCASE$(sNextChar)          'force uppercase
      IF iCaps = 2 THEN sNextChar = UCASE$(sNextChar)          'force lowercase
      SELECT CASE MID$(sMask,iMaskCount,1)                     'get mask character
         CASE "\" 'next char is literal
            INCR iMaskCount                                    'go to next mask char
            IF iMaskCount > LEN(sMask) THEN EXIT LOOP
            sTextOut = sTextOut + MID$(sMask,iMaskCount,1)     'and save this literal
            IF sNextChar <> MID$(sMask,iMaskCount,1) THEN DECR iCount'backup the input char since we didn't use it this time
            ITERATE LOOP
         CASE "#" 'Digit placeholder (entry required)
            IF sNextChar => "0" AND sNextChar =< "9" THEN
               sTextOut = sTextOut + sNextChar
            ELSE
               sTextOut = sTextOut + "_"                       'default since entry required
               iDone = %FALSE                                  'require input needed so return not ready
            END IF
         CASE "9" 'Digit placeholder (entry optional)
            IF sNextChar => "0" AND sNextChar =< "9" THEN
               sTextOut = sTextOut + sNextChar
            ELSE
               sTextOut = sTextOut + " "
            END IF
         CASE "&" 'character placeholder  32-126 And 128-255 (entry required)
            IF ASC(sNextChar) > 31 AND ASC(sNextChar) < 256 AND ASC(sNextChar) <> 127 THEN
               sTextOut = sTextOut + sNextChar
            ELSE
               sTextOut = sTextOut + "_"                       'default since entry required
               iDone = %FALSE                                  'require input needed so return not ready
            END IF
         CASE "A" 'alphanumeric placeholder (entry required)
            IF (sNextChar => "a" AND sNextChar =< "z") _
            OR (sNextChar => "A" AND sNextChar =< "Z") _
            OR (sNextChar => "0" AND sNextChar =< "9") THEN
               sTextOut = sTextOut + sNextChar
            ELSE
               sTextOut = sTextOut + "_"                       'default since entry required
               iDone = %FALSE                                  'require input needed so return not ready
            END IF
         CASE "a" 'alphanumeric placeholder (entry optional)
            IF (sNextChar => "a" AND sNextChar =< "z") _
            OR (sNextChar => "A" AND sNextChar =< "Z") _
            OR (sNextChar => "0" AND sNextChar =< "9") THEN
               sTextOut = sTextOut + sNextChar
            ELSE
               sTextOut = sTextOut + " "
            END IF
         CASE "L" 'letter or space placeholder (entry required)
            IF (sNextChar => "a" AND sNextChar =< "z") _
            OR (sNextChar => "A" AND sNextChar =< "Z") THEN
               sTextOut = sTextOut + sNextChar
            ELSE
               sTextOut = sTextOut + "_"
               iDone = %FALSE                                  'require input needed so return not ready
            END IF
         CASE "C" 'letter or space placeholder (entry optional)
            IF (sNextChar => "a" AND sNextChar =< "z") _
            OR (sNextChar => "A" AND sNextChar =< "Z") _
            OR (sNextChar = " ") THEN
               sTextOut = sTextOut + sNextChar
            ELSE
               sTextOut = sTextOut + " "
            END IF
         CASE "?" 'letter placeholder a-z A-Z (entry optional)
            IF (sNextChar => "a" AND sNextChar =< "z") _
            OR (sNextChar => "A" AND sNextChar =< "Z") THEN
               sTextOut = sTextOut + sNextChar
            ELSE
               sTextOut = sTextOut + " "
            END IF
         CASE ">"       'following chars will be forced to uppercase
            iCaps = 2
            DECR iCount 'we did not use the char to backup
         CASE "<"       'following chars will be forced to lowercase
            iCaps = 1
            DECR iCount 'we did not use the char to backup
         CASE "."       'get local decimal char
            IF ISFALSE GetLocaleInfo(%LOCALE_SYSTEM_DEFAULT, %LOCALE_SDECIMAL,  zBuff, 50) THEN zBuff = "/" 'decimal separator
            sTextOut = sTextOut + zBuff
            IF sNextChar <> zBuff THEN DECR iCount                   'backup the input char since we didn't use it this time
         CASE ","    'get local thousands char
            IF ISFALSE GetLocaleInfo(%LOCALE_SYSTEM_DEFAULT, %LOCALE_STHOUSAND,  zBuff, 50) THEN zBuff = "/" 'thousands separator
            sTextOut = sTextOut + zBuff
            IF sNextChar <> zBuff THEN DECR iCount                   'backup the input char since we didn't use it this time
         CASE "/"    'get local date char
            IF ISFALSE GetLocaleInfo(%LOCALE_SYSTEM_DEFAULT, %LOCALE_SDATE,  zBuff, 50) THEN zBuff = "/" 'date separator
            sTextOut = sTextOut + zBuff
            IF sNextChar <> zBuff THEN DECR iCount                   'backup the input char since we didn't use it this time
         CASE ":"    'get local time char
            IF ISFALSE GetLocaleInfo(%LOCALE_SYSTEM_DEFAULT, %LOCALE_STIME,  zBuff, 50) THEN zBuff = "/" 'time separator
            sTextOut = sTextOut + zBuff
            IF sNextChar <> zBuff THEN DECR iCount                   'backup the input char since we didn't use it this time
         CASE ELSE 'literal mask char
            sTextOut = sTextOut + MID$(sMask,iMaskCount,1)  'and save this literal
            IF sNextChar <> MID$(sMask,iMaskCount,1) THEN DECR iCount'backup the input char since we didn't use it this time
      END SELECT
   LOOP
   FUNCTION = iDone
   sTextOut = sTextOut + CHR$(0)
   iRet = SendMessage( hEdit, %WM_SETTEXT, 0, STRPTR(sTextOut) ) 'set text
   IF iCurPos < LEN(sMaskFields) AND MID$(sMaskFields,iCurPos + 1,1) <> "D" THEN iCurPos = MAX(INSTR(MAX(iCurPos + 1,1),sMaskFields,"D"),1) - 1 'fix cursor if not on data field
   CALL SendMessage( hEdit, %EM_SETSEL, iCurPos, iCurPos        )'set cursor back to the correct pos
END FUNCTION
'==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~==~
